/*
 * LLVID.C - low-level video primitives for bwBASIC/FD
 * Copyright (C) 2003, Stephen V. Nickolas <steve@dosius.zzn.com>
 *
 * This file is part of Bywater BASIC 2.20 for FreeDOS, version 0.01
 * Bywater BASIC for FreeDOS is free software; you may redistribute it
 * and/or modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
 * Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 */

#include <conio.h>
#include "ll.h"
#include "llvid.h" /* -ea */

extern byte * mcgascreen = /* MK_FP(0xa000, 0) */ \
  (void *) 0xa0000000L;

/* SCREEN() function - default mode to 0 if not supplied */
byte llvid_screen_func (byte y, byte x, byte mode)
{
 int tmp_x, tmp_y;
 union REGS r;

 r.h.ah = 0x08;
 r.h.bh = 0x00; /* page 0; Borland conio doesn't support any other mode */

 tmp_x=wherex();
 tmp_y=wherey();
 gotoxy(x,y);

 /* work around possible BIOS bugs by saving these regs -uso. */
 int86(0x10, &r, &r);

 gotoxy(tmp_x,tmp_y);

 if (!mode) return r.h.al; /* character */
   else return r.h.ah; /* attribute */
}

/* PALETTE command - only for PCjr/Tandy and EGA/VGA */
void llvid_palette (byte col, byte attr)
{
 union REGS r;
 r.x.ax = 0x1000;
 r.h.bl = col;
 r.h.bh = attr;
 int86(0x10, &r, &r);
}

/* Sets CGA mode 1 palette, for COLOR command.  This is not a complete
   command intrinsic implementation -uso. */
void llvid_cga1_setfg (byte mode)
{
 union REGS r;
 r.h.ah =0x0B;
 r.h.bh = 0x01;
 r.h.bl = mode;
 int86(0x10, &r, &r);
}

/* PSET() function - default c to no_colors-1 if not supplied */
/* Bonus feature: if the BIOS supports it (it should!) a color value >127
   will XOR the pixel onto the screen (RBIL) -uso. */
void llvid_pset (word x, word y, byte c)
{
 union REGS r;
 r.h.ah = 0x0C;
 r.h.bh = 0x00; /* page 0 */
 r.x.cx = x;
 r.x.dx = y;
 r.h.al = c;
 int86(0x10, &r, &r);
}

/* And this version for SCREEN 13 */
void llvid_mcga_pset (word x, word y, byte c)
{
 if (x<0 || x>319 || y<0 || y>199) return; /* documented -uso. */
 mcgascreen[x+(y*320)] = c;
}

/* POINT() function */
byte llvid_point (word x, word y)
{
 union REGS r;
 r.h.ah = 0x0D;
 r.h.bh = 0x00; /* page 0 */
 r.x.cx = x;
 r.x.dx = y;
 int86(0x10, &r, &r);
 return r.h.al;
}

/* And this version for SCREEN 13 */
byte llvid_mcga_point (word x, word y)
{
 if (x<0 || x>319 || y<0 || y>199) return 0; /* off-screen */
 return mcgascreen[x+(y*320)];
}
